#include "ModbusDataInterface.h"
#include <algorithm>

/*
Collects all ModbusRegister which fulfill the specified category
	cat: specified category to look for
	queue: reference to a thread safe queue, which contains the readable registers
return: the queue with the enqueued values
*/
ts_queue<ParameterSpecification>& ModbusDataInterface::modbusRegisterCat(const Category cat, ts_queue<ParameterSpecification>& queue, std::unique_ptr<ModbusInterface>& connection)
{
    std::for_each(modbusParamFP32.begin(),		modbusParamFP32.end(),		[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });
    std::for_each(modbusParamFP64.begin(),		modbusParamFP64.end(),		[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });
    std::for_each(modbusParamU16.begin(),		modbusParamU16.end(),		[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });
    std::for_each(modbusParamU32.begin(),		modbusParamU32.end(),		[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });
    std::for_each(modbusParamS16.begin(),		modbusParamS16.end(),		[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });
    std::for_each(modbusParamString.begin(),	modbusParamString.end(),	[&queue, cat, &connection](const auto& p)	{ if (cat == p.getCategory())  queue.push(p.getSpecification(connection)); });

	return queue;
}
