#pragma once
#include <vector>
#include <string>
#include <any>
#include <sstream>
#include <optional>
#include "ts_queue.h"
#include "ParameterDouble.h"
#include "ParameterFloat.h"
#include "ParameterUInt16.h"
#include "ParameterUInt32.h"
#include "ParameterCharP.h"
#include "ParameterS16.h"

class ModbusInterface;

class ModbusDataInterface
{
private:
	const unsigned int id;
protected:
	std::vector<ParameterFloat>		modbusParamFP32;
	std::vector<ParameterDouble>	modbusParamFP64;
	std::vector<ParameterUInt16>	modbusParamU16;
	std::vector<ParameterUInt32>	modbusParamU32;
	std::vector<ParameterS16>		modbusParamS16;
	std::vector<ParameterCharP>	    modbusParamString;
public:
	ModbusDataInterface(const unsigned int id) : id(id) { }
	
    ts_queue<ParameterSpecification>& modbusRegisterCat(const Category cat, ts_queue<ParameterSpecification>& queue, std::unique_ptr<ModbusInterface> &connection);

    void readAll();
};
