#pragma once	


enum class Category {
    //Category for collective reading accesses
    NONE,
    Condition,
    Diagnosis,
    Alert
};


enum class ModbusRegister {
    //---------------------Powercenter----------------------------
	//Information for identification
        POC_Ident_Manufacturer,
        POC_Ident_Ordernumber,
        POC_Ident_Seriesnumber,
        POC_Ident_Hardware_Version,
        POC_Ident_Software_Version,
        POC_Ident_Plant_identification_code,
        POC_Ident_Installation_site,
        POC_Ident_Installation_date,
        POC_Ident_Firmware_Applicationcontroller,
        POC_Ident_Market,
        POC_Ident_Main_device_rated_current,
        POC_Ident_Tripping_curve_characteristic,
        POC_Ident_Installation_place_fuse,
        POC_Ident_MLFB_fuse,
        POC_Ident_Hardware_Electronics,
        POC_Ident_rated_current_melting_part,
	//IP Information
        POC_IP_Ethernet_MAC,
        POC_IP_Status_DHCP,
        POC_IP_SNTP_server_ip,
        POC_IP_SNTP_client_mode,
        POC_IP_Status_firewall,
        POC_IP_port_number,
        POC_IP_Static_IP,
        POC_IP_Subnetmask,
        POC_IP_Gateway,
        POC_IP_Current_IP,
        POC_IP_Current_Subnet,
        POC_IP_Current_Gateway,
	//Bluetooth Information
        POC_BT_Status,
        POC_BT_send_power,
        POC_BT_device_address,
        POC_BT_passkey,
	//Radio Information
        POC_Radio_Date_time_utc,
        POC_Radio_Paring_status_1,
        POC_Radio_Paring_status_2,
        POC_Radio_Paring_status_3,
        POC_Radio_Paring_status_4,
        POC_Radio_Paring_status_5,
        POC_Radio_Paring_status_6,
        POC_Radio_Paring_status_7,
        POC_Radio_Paring_status_8,
        POC_Radio_Paring_status_9,
        POC_Radio_Paring_status_10,
        POC_Radio_Paring_status_11,
        POC_Radio_Paring_status_12,
        POC_Radio_Paring_status_13,
        POC_Radio_Paring_status_14,
        POC_Radio_Paring_status_15,
        POC_Radio_Paring_status_16,
        POC_Radio_Paring_status_17,
        POC_Radio_Paring_status_18,
        POC_Radio_Paring_status_19,
        POC_Radio_Paring_status_20,
        POC_Radio_Paring_status_21,
        POC_Radio_Paring_status_22,
        POC_Radio_Paring_status_23,
        POC_Radio_Paring_status_24,
        POC_Radio_transmit_power,
        POC_Radio_Device_status_1,
        POC_Radio_Device_status_2,
        POC_Radio_Device_status_3,
        POC_Radio_Device_status_4,
        POC_Radio_Device_status_5,
        POC_Radio_Device_status_6,
        POC_Radio_Device_status_7,
        POC_Radio_Device_status_8,
        POC_Radio_Device_status_9,
        POC_Radio_Device_status_10,
        POC_Radio_Device_status_11,
        POC_Radio_Device_status_12,
        POC_Radio_Device_status_13,
        POC_Radio_Device_status_14,
        POC_Radio_Device_status_15,
        POC_Radio_Device_status_16,
        POC_Radio_Device_status_17,
        POC_Radio_Device_status_18,
        POC_Radio_Device_status_19,
        POC_Radio_Device_status_20,
        POC_Radio_Device_status_21,
        POC_Radio_Device_status_22,
        POC_Radio_Device_status_23,
        POC_Radio_Device_status_24,
        POC_Radio_Time_sync_to_POC,
	//Radio Communication Information
        POC_RadioCom_Mac_address_device_1,
        POC_RadioCom_Mac_address_device_2,
        POC_RadioCom_Mac_address_device_3,
        POC_RadioCom_Mac_address_device_4,
        POC_RadioCom_Mac_address_device_5,
        POC_RadioCom_Mac_address_device_6,
        POC_RadioCom_Mac_address_device_7,
        POC_RadioCom_Mac_address_device_8,
        POC_RadioCom_Mac_address_device_9,
        POC_RadioCom_Mac_address_device_10,
        POC_RadioCom_Mac_address_device_11,
        POC_RadioCom_Mac_address_device_12,
        POC_RadioCom_Mac_address_device_13,
        POC_RadioCom_Mac_address_device_14,
        POC_RadioCom_Mac_address_device_15,
        POC_RadioCom_Mac_address_device_16,
        POC_RadioCom_Mac_address_device_17,
        POC_RadioCom_Mac_address_device_18,
        POC_RadioCom_Mac_address_device_19,
        POC_RadioCom_Mac_address_device_20,
        POC_RadioCom_Mac_address_device_21,
        POC_RadioCom_Mac_address_device_22,
        POC_RadioCom_Mac_address_device_23,
        POC_RadioCom_Mac_address_device_24,

	//Measurement Settings
        POC_Measurement_Time_period_temperature,
        POC_Measurement_Activate_temp_alert,
        POC_Measurement_Limit_temperature_alert,
        POC_Measurement_Hysteresis_temperature_alert,
        POC_Measurement_I_Averaging_interval_s,
		//Current Alerts
        POC_Measurement_I_alert1_over_on_off,
        POC_Measurement_I_alert1_over_limit_percentage,
        POC_Measurement_I_alert1_over_hysteresis,
        POC_Measurement_I_alert2_over_on_off,
        POC_Measurement_I_alert2_over_limit_percentage,
        POC_Measurement_I_alert2_over_hysteresis,
        POC_Measurement_I_alert1_under_on_off,
        POC_Measurement_I_alert1_under_limit_percentage,
        POC_Measurement_I_alert1_under_hysteresis,
        POC_Measurement_I_alert2_under_on_off,
        POC_Measurement_I_alert2_under_limit_percentage,
        POC_Measurement_I_alert2_under_hysteresis,
		//Voltage Alerts
        POC_Measurement_U_alert1_over_on_off,
        POC_Measurement_U_alert1_over_limit_percentage,
        POC_Measurement_U_alert1_over_hysteresis,
        POC_Measurement_U_alert2_over_on_off,
        POC_Measurement_U_alert2_over_limit_percentage,
        POC_Measurement_U_alert2_over_hysteresis,
        POC_Measurement_U_alert1_under_on_off,
        POC_Measurement_U_alert1_under_limit_percentage,
        POC_Measurement_U_alert1_under_hysteresis,
        POC_Measurement_U_alert2_under_on_off,
        POC_Measurement_U_alert2_under_limit_percentage,
        POC_Measurement_U_alert2_under_hysteresis,

        POC_Measurement_Energy_flow_direction,
        POC_Measurement_Alert_on_off_AFDD_threshold_shortfall,

	//Switch gears condition
        POC_Cond_Temp,							//C
        POC_Cond_Temp_avg,    					//C
        POC_Cond_I_Phase,     					//A
        POC_Cond_I_Phase_avg, 					//A
        POC_Cond_I_Phase_max, 					//A
        POC_Cond_U_L_N,							//V
        POC_Cond_Freq,							//Hz
        POC_Cond_P,								//W
        POC_Cond_S,								//W
        POC_Cond_Q,								//Var
        POC_Cond_Cos_phi,
        POC_Cond_P_in,							//Wh
        POC_Cond_P_ab,							//Wh
        POC_Cond_S_in,							//Varh
        POC_Cond_S_ab,							//Varh
        POC_Cond_Status,

	//Powercenter Diagnosis
        POC_Diag_Alert,
		//Hours run with current flow
        POC_Diag_H_run_with_I,					//s
        POC_Diag_Alert_on_off_run_total_with_I,
        POC_Diag_Min_load_current,
        POC_Diag_Limit_run_hours_with_I_alert,
        POC_Diag_H_run_total,					//s
        POC_Diag_Alert_on_off_run_total,
        POC_Diag_Limit_run_hours_total_alert,
        POC_Diag_Nr_of_mechanical_switchings,
        POC_Diag_Alert_on_off_nr_mechanical_switchings,
        POC_Diag_Limit_mechanical_switchings,
        POC_Diag_Nr_of_triggered_switches,
        POC_Diag_Alert_on_off_nr_triggered_switchings,
        POC_Diag_Limit_triggered_switchings,
		//Received Signal Strength Indicator in dbm
        POC_Diag_RSSI_BLE,
        POC_Diag_RSSI_radio,
        POC_Diag_Nr_of_short_circuit_triggers,
        POC_Diag_Alert_on_off_nr_short_circuit_triggers,
        POC_Diag_Limit_shoer_circuit_triggers,
        POC_Diag_Time_and_sync_status,

	//Radio communication settings
        POC_RadioCom_Installation_Code_1,
        POC_RadioCom_Installation_Code_2,
        POC_RadioCom_Installation_Code_3,
        POC_RadioCom_Installation_Code_4,
        POC_RadioCom_Installation_Code_5,
        POC_RadioCom_Installation_Code_6,
        POC_RadioCom_Installation_Code_7,
        POC_RadioCom_Installation_Code_8,
        POC_RadioCom_Installation_Code_9,
        POC_RadioCom_Installation_Code_10,
        POC_RadioCom_Installation_Code_11,
        POC_RadioCom_Installation_Code_12,
        POC_RadioCom_Installation_Code_13,
        POC_RadioCom_Installation_Code_14,
        POC_RadioCom_Installation_Code_15,
        POC_RadioCom_Installation_Code_16,
        POC_RadioCom_Installation_Code_17,
        POC_RadioCom_Installation_Code_18,
        POC_RadioCom_Installation_Code_19,
        POC_RadioCom_Installation_Code_20,
        POC_RadioCom_Installation_Code_21,
        POC_RadioCom_Installation_Code_22,
        POC_RadioCom_Installation_Code_23,
        POC_RadioCom_Installation_Code_24,

        POC_RadioCom_Paring_Device,

        POC_RadioCom_Paring_device_1,
        POC_RadioCom_Paring_device_2,
        POC_RadioCom_Paring_device_3,
        POC_RadioCom_Paring_device_4,
        POC_RadioCom_Paring_device_5,
        POC_RadioCom_Paring_device_6,
        POC_RadioCom_Paring_device_7,
        POC_RadioCom_Paring_device_8,
        POC_RadioCom_Paring_device_9,
        POC_RadioCom_Paring_device_10,
        POC_RadioCom_Paring_device_11,
        POC_RadioCom_Paring_device_12,
        POC_RadioCom_Paring_device_13,
        POC_RadioCom_Paring_device_14,
        POC_RadioCom_Paring_device_15,
        POC_RadioCom_Paring_device_16,
        POC_RadioCom_Paring_device_17,
        POC_RadioCom_Paring_device_18,
        POC_RadioCom_Paring_device_19,
        POC_RadioCom_Paring_device_20,
        POC_RadioCom_Paring_device_21,
        POC_RadioCom_Paring_device_22,
        POC_RadioCom_Paring_device_23,
        POC_RadioCom_Paring_device_24,


    //---------------------Bender----------------------------
    //Test variable to be read from virtual RCM device
        BENDER_Residual_current,
};


namespace CMD {
	enum class Identification {
		Trigger_flash_light,
	};

	enum class IP {
		Apply_ethernet_configuration_changes,
	};

	enum class Bluetooth {
		Switch_on_off_BT_Reset_passkey,
	};

	enum class MeasurementSettings {
		Reset_energy_counter,
		Reset_extrem_values,
	};
}
